import { createSlice } from "@reduxjs/toolkit";
import { useSelector } from "react-redux";

const User = createSlice({
  name: "user",
  initialState: {
    codeHash: "",
    isLoggedIn: false,
    user: {},
  },
  reducers: {
    login: (state, action) => {
      state.isLoggedIn = true;
      state.user = action.payload;
    },
    logout: (state) => {
      state.isLoggedIn = false;
      state.user = {};
    },
    setCodeHash: (state, action) => {
      state.codeHash = action.payload;
    },
  },
});

export function useSelectorUser() {
  return useSelector((state: any) => state.user.user);
}

export function useSelectorIsLoggedIn() {
  return useSelector((state: any) => state.user.isLoggedIn);
}

export function useSelectCodeHash() {
  return useSelector((state: any) => state.user.codeHash);
}

export const { login, logout, setCodeHash } = User.actions;

export default User.reducer;
